<template>
  <div class="container">
    <div class="post-container" style="width:100%">
      <div class="post-card" v-for="post in posts" :key="post.id">
        <BotonEditarPublicacionVue :publicacion="post"/>
        <div class="post-wrapper">
          <div class="user-info">
            <UserAvatarVue :usuario="post.muro.usuario" class="user-avatar"/>
            <div class="user-name">{{ post.username }}</div>
          </div>
          <div class="post-title">{{ post.title }}</div>
          <div class="post-content">{{ post.content }}</div>
          <div class="post-footer">
            <div class="actions">
              <lista-reacciones :publicacionId="post.id"></lista-reacciones>

              <div class="action-container comment-container">
                <button class="action comment-btn" @click="showCommentOverlay(post)">
                  <i class="bi bi-chat-fill"></i> Comentar
                </button>
              </div>
              <div class="action-container">
                <button class="action">
                  <i class="bi bi-share-fill"></i> Compartir
                </button>
              </div>
            </div>
          </div>
          <div class="post-image-container">
            <MostrarImagenesPublicacionVue :nombreImagenes="post.imagenes" :textoImagenes="post.textoDeLaImagen" />
            <!--<img :src="require('@/assets/Diamond.jpg')" alt="Post Image" class="post-image" />-->
          </div>
        </div>
      </div>
    </div>
    <div class="comment-overlay" v-if="selectedPost">
      <div class="comment-card">
        <h2 class="post-title" style="width: 100%;">
          Publicación de {{ selectedPost.username }}
          <hr class="divider" />
        </h2>
        <button class="close-btn" @click="hideCommentOverlay">
          <i class="bi bi-x"></i>
        </button>
        <div class="post-wrapper">
          <div class="user-info">
            <div class="user-avatar">
              <img :src="selectedPost.avatar" alt="User Avatar" class="avatar-image" />
            </div>
            <div class="user-name">{{ selectedPost.username }}</div>
          </div>
          <div class="post-title">{{ selectedPost.title }}</div>
          <div class="post-content">{{ selectedPost.content }}</div>
          <div class="post-footer" v-if="selectedPost.showActions">
            <div class="actions">
              <div class="action-container">
                <button class="action like-btn">
                  <i class="bi bi-hand-thumbs-up-fill"></i> Me gusta
                </button>
              </div>
              <div class="action-container">
                <button class="action">
                  <i class="bi bi-share-fill"></i> Compartir
                </button>
              </div>
            </div>
          </div>
          <div class="post-image-container">
            <MostrarImagenesPublicacionVue :nombreImagenes="selectedPost.imagenes" :textoImagenes="selectedPost.textoDeLaImagen" />
          </div>
          <lista-comentarios :comments="selectedPost.comments" :post-id="selectedPostId"  ></lista-comentarios>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ListaComentarios from '@/components/coment_react/ListaComentarios.vue';
import ListaReacciones from '@/components/coment_react/ListaReacciones.vue';
import MostrarImagenesPublicacionVue from '../public_histo/MostrarImagenesPublicacion.vue';
import BotonEditarPublicacionVue from '../muro/BotonEditarPublicacion.vue';
import UserAvatarVue from '../muro/UserAvatar.vue';


export default {
  components: {
    MostrarImagenesPublicacionVue,
    ListaComentarios,
    ListaReacciones,
    BotonEditarPublicacionVue,
    UserAvatarVue
  },
  props:{
    posts:[]
  },
  data() {
    return {
      selectedPost:null,
      selectedPostId: null,
      selectPublicacionId: null,
    } 
  },
  methods: {
    showCommentOverlay(post) {
      post.showActions = false;
      post.showComments = true;
      this.selectedPost = post;
      this.selectedPostId = post.id;
      document.body.style.overflow = "hidden";
      console.log(this.selectedPost);
    },
    hideCommentOverlay() {
      this.selectedPost.showActions = true;
      this.selectedPost.showComments = false;
      this.selectedPost = null;
      document.body.style.overflow = "";
    },

    showReplyForm(comment) {
      comment.showReplyForm = true;
    },
    toggleIconSelection() {
      this.iconSelected = !this.iconSelected;
    },
    selectImage() {
      this.selected = !this.selected;
      this.imageVisible = !this.selected;
    },
    
  },
  mounted(){
   console.log(this.posts);
  }
};
</script>



<style scoped>
.post-container {
  height: 400px;
  /* Establece una altura fija para el contenedor de los posts */
  overflow-y: scroll;
  /* Permite la barra de desplazamiento vertical */
}

.post-header {
  display: flex;
  align-items: center;
}

.container {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.post-title {
  font-size: 18px;
  font-weight: bold;
  color: black;
  position: relative;
  top: 1px;
  left: 50%;
  transform: translateX(-50%);
  z-index: 1;
  flex-grow: 1;
}

.divider {
  width: 100%;
}

.post-container {
  flex: 1;
  overflow-y: auto;
  margin-top: 70px;
}

.comment-overlay .user-avatar {
  width: 40px;
  height: 40px;
  border-radius: 50%;
  overflow: hidden;
  margin-right: 10px;
}

.post-card {
  width: 590px;
  height: 740px;
  background-color: #ffffff;
  padding: 20px;
  border-radius: 8px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  margin-bottom: 20px;
  position: relative;
}

.underline {
  text-decoration: underline;
}

.hoverable:hover {
  cursor: pointer;
  opacity: 0.7;
}

.subtle {
  color: #999999;
}

.post-wrapper {
  padding: 10px;

}

.user-info {
  display: flex;
  align-items: center;
  margin-bottom: 10px;
}

.user-avatar {
  width: 40px;
  height: 40px;
  border-radius: 50%;
  overflow: hidden;
  margin-right: 10px;
}

.avatar-image {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

.user-name {
  font-weight: bold;
}

.actions {
  position: absolute;
  bottom: 10px;
  left: 0;
  right: 0;
  display: flex;
  justify-content: center;
  border-top: 1px solid #ccc;
  padding-top: 2px;
  z-index: 1;
  /* Agrega un valor de z-index */
}

.action-container {
  display: inline-flex;
  align-items: center;
  margin-right: 10px;
  cursor: pointer;
}

.like-btn {
  margin-right: 5px;
  margin-left: 65px;

}

.comment-container {
  margin-left: auto;
  margin-right: auto;
}

.action-container:last-child {
  margin-right: 65px;
}

.comment-btn {
  margin-right: 0;
}


.post-content {
  text-align: left;
}

.post-image-container {
  display: flex;
  justify-content: center;
  margin-top: 10px;
  margin-bottom: 10px;
  position: relative;
  /* Agrega posición relativa al contenedor */
}

.post-image {
  width: 100%;
  max-height: 530px;
  object-fit: contain;
}

.comment-overlay {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.5);
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 9999;
}



.comment-card {
  width: 790px;
  max-height: 680px;
  background-color: #ffffff;
  padding: 20px;
  border-radius: 8px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  overflow-y: auto;
  position: relative;
}

.comment-card .post-wrapper {
  padding: 10px;
  margin-top: -20px;
}

.comment-card .user-info {
  display: flex;
  align-items: center;
  margin-bottom: 10px;
}

.comment-card .user-avatar {
  width: 40px;
  height: 40px;
  border-radius: 50%;
  overflow: hidden;
  margin-right: 10px;
  align-self: center;
}

.comment-card .avatar-image {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

.comment-card .comment-input {
  display: flex;
  align-items: center;
}

.comment-card .send-comment-btn {
  margin-left: 10px;
}

.comment-card .user-name {
  font-weight: bold;
}

.comment-card .actions {
  display: flex;
  justify-content: flex-end;
}

.comment-card .action-container {
  display: inline-flex;
  align-items: center;
  margin-right: 10px;
  cursor: pointer;
}

.comment-card .like-btn {
  margin-right: 5px;
  margin-left: 65px;
}

.comment-card .comment-container {
  margin-left: auto;
  margin-right: auto;
}

.comment-card .action-container:last-child {
  margin-right: 0;
}

.comment-card .comment-btn {
  margin-right: 0;
}

.comment-card .likes {
  margin-bottom: 10px;
}

.comment-card .post-content {
  text-align: left;
}

.comment-card .post-image-container {
  display: flex;
  justify-content: center;
  margin-top: 10px;
}

.comment-card .post-image {
  width: 100%;
  max-height: 530px;
  object-fit: contain;
}

.close-btn {
  position: absolute;
  top: 17px;
  right: 30px;
  width: 32px;
  height: 32px;
  background: #efeaea;
  border-radius: 50%;
  border: none;
  cursor: pointer;
  display: flex;
  align-items: center;
  justify-content: center;
  transition: background-color 0.3s ease;
  /* Agregamos una transición suave para el cambio de color */
}

.close-btn:hover {
  background-color: #c5c1c1;
  /* Cambiamos el color de fondo al pasar el cursor sobre el botón */
}

.close-btn i {
  font-size: 24px;
  color: #242323;
  transform: scale(1.2);
}

.comment-overlay .post-card .action-container:nth-child(1),
.comment-overlay .post-card .action-container:nth-child(3) {
  display: none;
}

.comment-overlay .post-card .post-content {
  height: 200px;
  overflow-y: auto;
}

.comments {
  margin-top: 20px;
  border-top: 1px solid #ccc;
  padding-top: 10px;
}



.comment .user-info {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  margin-bottom: 0;
}

.comment .user-avatar {
  width: 30px;
  height: 30px;
  border-radius: 50%;
  overflow: hidden;
  margin-right: 10px;
}


.comment .avatar-image {
  width: 100%;
  height: 100%;
  object-fit: cover;
}

.comment .user-name {
  font-size: 13px;
  color: #333333;
  font-weight: bold;
}

.comment .comment-content {
  text-align: left;
}

.comment-overlay .post-card .action-container:nth-child(1),
.comment-overlay .post-card .action-container:nth-child(3) {
  display: none;
}

.comment-overlay .post-card .post-content {
  height: 200px;
  overflow-y: auto;
}

.action {
  border: none;
  background-color: transparent;
  cursor: pointer;
  padding: 5px;
  border-radius: 20px;
  transition: background-color 0.3s, border-color 0.3s;
}

/* Estilos para resaltar los botones al pasar el mouse por encima */
.action:hover {
  background-color: #f0f0f0;
  border-color: #ccc;
}

.comment-content {
  margin-left: 39px;
  margin-top: -10px;
  font-size: 14px;

}
</style>